/*
 * Copyright (c) 2004-2008 Apple Inc. All rights reserved.
 *
 * @APPLE_OSREFERENCE_LICENSE_HEADER_START@
 *
 * This file contains Original Code and/or Modifications of Original Code
 * as defined in and that are subject to the Apple Public Source License
 * Version 2.0 (the 'License'). You may not use this file except in
 * compliance with the License. The rights granted to you under the License
 * may not be used to create, or enable the creation or redistribution of,
 * unlawful or unlicensed copies of an Apple operating system, or to
 * circumvent, violate, or enable the circumvention or violation of, any
 * terms of an Apple operating system software license agreement.
 *
 * Please obtain a copy of the License at
 * http://www.opensource.apple.com/apsl/ and read it before using this file.
 *
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR NON-INFRINGEMENT.
 * Please see the License for the specific language governing rights and
 * limitations under the License.
 *
 * @APPLE_OSREFERENCE_LICENSE_HEADER_END@
 *
 *
 * System call switch table.
 *
 * DO NOT EDIT-- this file is automatically generated.
 * created from /Users/adam/Documents/sources/xnu/build/xnu-6153.11.26/bsd/kern/syscalls.master
 */

#define SOCKETS            1
#define PSYNCH             1
#define CONFIG_WORKQUEUE   1
#define OLD_SEMWAIT_SIGNAL 1

const char *syscallnames[] = {
    "syscall",   /* 0 = syscall indirect syscall */
    "exit",      /* 1 = exit */
    "fork",      /* 2 = fork */
    "read",      /* 3 = read */
    "write",     /* 4 = write */
    "open",      /* 5 = open */
    "close",     /* 6 = close */
    "wait4",     /* 7 = wait4 */
    "#8",        /* 8 = old creat */
    "link",      /* 9 = link */
    "unlink",    /* 10 = unlink */
    "#11",       /* 11 = old execv */
    "chdir",     /* 12 = chdir */
    "fchdir",    /* 13 = fchdir */
    "mknod",     /* 14 = mknod */
    "chmod",     /* 15 = chmod */
    "chown",     /* 16 = chown */
    "#17",       /* 17 = old break */
    "getfsstat", /* 18 = getfsstat */
    "#19",       /* 19 = old lseek */
    "getpid",    /* 20 = getpid */
    "#21",       /* 21 = old mount */
    "#22",       /* 22 = old umount */
    "setuid",    /* 23 = setuid */
    "getuid",    /* 24 = getuid */
    "geteuid",   /* 25 = geteuid */
    "ptrace",    /* 26 = ptrace */
#if SOCKETS
    "recvmsg",     /* 27 = recvmsg */
    "sendmsg",     /* 28 = sendmsg */
    "recvfrom",    /* 29 = recvfrom */
    "accept",      /* 30 = accept */
    "getpeername", /* 31 = getpeername */
    "getsockname", /* 32 = getsockname */
#else
    "#27", /* 27 = */
    "#28", /* 28 = */
    "#29", /* 29 = */
    "#30", /* 30 = */
    "#31", /* 31 = */
    "#32", /* 32 = */
#endif /* SOCKETS */
    "access",        /* 33 = access */
    "chflags",       /* 34 = chflags */
    "fchflags",      /* 35 = fchflags */
    "sync",          /* 36 = sync */
    "kill",          /* 37 = kill */
    "#38",           /* 38 = old stat */
    "getppid",       /* 39 = getppid */
    "#40",           /* 40 = old lstat */
    "dup",           /* 41 = dup */
    "pipe",          /* 42 = pipe */
    "getegid",       /* 43 = getegid */
    "#44",           /* 44 = old profil */
    "#45",           /* 45 = old ktrace */
    "sigaction",     /* 46 = sigaction */
    "getgid",        /* 47 = getgid */
    "sigprocmask",   /* 48 = sigprocmask */
    "getlogin",      /* 49 = getlogin */
    "setlogin",      /* 50 = setlogin */
    "acct",          /* 51 = acct */
    "sigpending",    /* 52 = sigpending */
    "sigaltstack",   /* 53 = sigaltstack */
    "ioctl",         /* 54 = ioctl */
    "reboot",        /* 55 = reboot */
    "revoke",        /* 56 = revoke */
    "symlink",       /* 57 = symlink */
    "readlink",      /* 58 = readlink */
    "execve",        /* 59 = execve */
    "umask",         /* 60 = umask */
    "chroot",        /* 61 = chroot */
    "#62",           /* 62 = old fstat */
    "#63",           /* 63 = used internally and reserved */
    "#64",           /* 64 = old getpagesize */
    "msync",         /* 65 = msync */
    "vfork",         /* 66 = vfork */
    "#67",           /* 67 = old vread */
    "#68",           /* 68 = old vwrite */
    "#69",           /* 69 = old sbrk */
    "#70",           /* 70 = old sstk */
    "#71",           /* 71 = old mmap */
    "#72",           /* 72 = old vadvise */
    "munmap",        /* 73 = munmap */
    "mprotect",      /* 74 = mprotect */
    "madvise",       /* 75 = madvise */
    "#76",           /* 76 = old vhangup */
    "#77",           /* 77 = old vlimit */
    "mincore",       /* 78 = mincore */
    "getgroups",     /* 79 = getgroups */
    "setgroups",     /* 80 = setgroups */
    "getpgrp",       /* 81 = getpgrp */
    "setpgid",       /* 82 = setpgid */
    "setitimer",     /* 83 = setitimer */
    "#84",           /* 84 = old wait */
    "swapon",        /* 85 = swapon */
    "getitimer",     /* 86 = getitimer */
    "#87",           /* 87 = old gethostname */
    "#88",           /* 88 = old sethostname */
    "getdtablesize", /* 89 = getdtablesize */
    "dup2",          /* 90 = dup2 */
    "#91",           /* 91 = old getdopt */
    "fcntl",         /* 92 = fcntl */
    "select",        /* 93 = select */
    "#94",           /* 94 = old setdopt */
    "fsync",         /* 95 = fsync */
    "setpriority",   /* 96 = setpriority */
#if SOCKETS
    "socket",  /* 97 = socket */
    "connect", /* 98 = connect */
#else
    "#97", /* 97 = */
    "#98", /* 98 = */
#endif /* SOCKETS */
    "#99",         /* 99 = old accept */
    "getpriority", /* 100 = getpriority */
    "#101",        /* 101 = old send */
    "#102",        /* 102 = old recv */
    "#103",        /* 103 = old sigreturn */
#if SOCKETS
    "bind",       /* 104 = bind */
    "setsockopt", /* 105 = setsockopt */
    "listen",     /* 106 = listen */
#else
    "#104", /* 104 = */
    "#105", /* 105 = */
    "#106", /* 106 = */
#endif /* SOCKETS */
    "#107",       /* 107 = old vtimes */
    "#108",       /* 108 = old sigvec */
    "#109",       /* 109 = old sigblock */
    "#110",       /* 110 = old sigsetmask */
    "sigsuspend", /* 111 = sigsuspend */
    "#112",       /* 112 = old sigstack */
#if SOCKETS
    "#113", /* 113 = old recvmsg */
    "#114", /* 114 = old sendmsg */
#else
    "#113", /* 113 = */
    "#114", /* 114 = */
#endif /* SOCKETS */
    "#115",         /* 115 = old vtrace */
    "gettimeofday", /* 116 = gettimeofday */
    "getrusage",    /* 117 = getrusage */
#if SOCKETS
    "getsockopt", /* 118 = getsockopt */
#else
    "#118", /* 118 = */
#endif /* SOCKETS */
    "#119",         /* 119 = old resuba */
    "readv",        /* 120 = readv */
    "writev",       /* 121 = writev */
    "settimeofday", /* 122 = settimeofday */
    "fchown",       /* 123 = fchown */
    "fchmod",       /* 124 = fchmod */
    "#125",         /* 125 = old recvfrom */
    "setreuid",     /* 126 = setreuid */
    "setregid",     /* 127 = setregid */
    "rename",       /* 128 = rename */
    "#129",         /* 129 = old truncate */
    "#130",         /* 130 = old ftruncate */
    "flock",        /* 131 = flock */
    "mkfifo",       /* 132 = mkfifo */
#if SOCKETS
    "sendto",     /* 133 = sendto */
    "shutdown",   /* 134 = shutdown */
    "socketpair", /* 135 = socketpair */
#else
    "#133", /* 133 = */
    "#134", /* 134 = */
    "#135", /* 135 = */
#endif /* SOCKETS */
    "mkdir",       /* 136 = mkdir */
    "rmdir",       /* 137 = rmdir */
    "utimes",      /* 138 = utimes */
    "futimes",     /* 139 = futimes */
    "adjtime",     /* 140 = adjtime */
    "#141",        /* 141 = old getpeername */
    "gethostuuid", /* 142 = gethostuuid */
    "#143",        /* 143 = old sethostid */
    "#144",        /* 144 = old getrlimit */
    "#145",        /* 145 = old setrlimit */
    "#146",        /* 146 = old killpg */
    "setsid",      /* 147 = setsid */
    "#148",        /* 148 = old setquota */
    "#149",        /* 149 = old qquota */
    "#150",        /* 150 = old getsockname */
    "getpgid",     /* 151 = getpgid */
    "setprivexec", /* 152 = setprivexec */
    "pread",       /* 153 = pread */
    "pwrite",      /* 154 = pwrite */
#if NFSSERVER
    "nfssvc", /* 155 = nfssvc */
#else
    "#155", /* 155 = */
#endif
    "#156",    /* 156 = old getdirentries */
    "statfs",  /* 157 = statfs */
    "fstatfs", /* 158 = fstatfs */
    "unmount", /* 159 = unmount */
    "#160",    /* 160 = old async_daemon */
#if NFSSERVER
    "getfh", /* 161 = getfh */
#else
    "#161", /* 161 = */
#endif
    "#162",                /* 162 = old getdomainname */
    "#163",                /* 163 = old setdomainname */
    "#164",                /* 164 = */
    "quotactl",            /* 165 = quotactl */
    "#166",                /* 166 = old exportfs */
    "mount",               /* 167 = mount */
    "#168",                /* 168 = old ustat */
    "csops",               /* 169 = csops */
    "csops_audittoken",    /* 170 = csops_audittoken */
    "#171",                /* 171 = old wait3 */
    "#172",                /* 172 = old rpause */
    "waitid",              /* 173 = waitid */
    "#174",                /* 174 = old getdents */
    "#175",                /* 175 = old gc_control */
    "#176",                /* 176 = old add_profil */
    "kdebug_typefilter",   /* 177 = kdebug_typefilter */
    "kdebug_trace_string", /* 178 = kdebug_trace_string */
    "kdebug_trace64",      /* 179 = kdebug_trace64 */
    "kdebug_trace",        /* 180 = kdebug_trace */
    "setgid",              /* 181 = setgid */
    "setegid",             /* 182 = setegid */
    "seteuid",             /* 183 = seteuid */
    "sigreturn",           /* 184 = sigreturn */
    "#185",                /* 185 = old chud */
    "thread_selfcounts",   /* 186 = thread_selfcounts */
    "fdatasync",           /* 187 = fdatasync */
    "stat",                /* 188 = stat */
    "fstat",               /* 189 = fstat */
    "lstat",               /* 190 = lstat */
    "pathconf",            /* 191 = pathconf */
    "fpathconf",           /* 192 = fpathconf */
    "#193",                /* 193 = old getfsstat */
    "getrlimit",           /* 194 = getrlimit */
    "setrlimit",           /* 195 = setrlimit */
    "getdirentries",       /* 196 = getdirentries */
    "mmap",                /* 197 = mmap */
    "#198",                /* 198 = old __syscall */
    "lseek",               /* 199 = lseek */
    "truncate",            /* 200 = truncate */
    "ftruncate",           /* 201 = ftruncate */
    "sysctl",              /* 202 = sysctl */
    "mlock",               /* 203 = mlock */
    "munlock",             /* 204 = munlock */
    "undelete",            /* 205 = undelete */
    "#206",                /* 206 = old ATsocket */
    "#207",                /* 207 = old ATgetmsg */
    "#208",                /* 208 = old ATputmsg */
    "#209",                /* 209 = old ATsndreq */
    "#210",                /* 210 = old ATsndrsp */
    "#211",                /* 211 = old ATgetreq */
    "#212",                /* 212 = old ATgetrsp */
    "#213",                /* 213 = Reserved for AppleTalk */
    "#214",                /* 214 = */
    "#215",                /* 215 = */
    "open_dprotected_np",  /* 216 = open_dprotected_np */
    "fsgetpath_ext",       /* 217 = fsgetpath_ext */
    "#218",                /* 218 = old lstatv */
    "#219",                /* 219 = old fstatv */
    "getattrlist",         /* 220 = getattrlist */
    "setattrlist",         /* 221 = setattrlist */
    "getdirentriesattr",   /* 222 = getdirentriesattr */
    "exchangedata",        /* 223 = exchangedata */
    "#224",                /* 224 = old checkuseraccess or fsgetpath */
    "searchfs",            /* 225 = searchfs */
    "delete",              /* 226 = delete private delete ( Carbon semantics ) */
    "copyfile",            /* 227 = copyfile */
    "fgetattrlist",        /* 228 = fgetattrlist */
    "fsetattrlist",        /* 229 = fsetattrlist */
    "poll",                /* 230 = poll */
    "watchevent",          /* 231 = watchevent */
    "waitevent",           /* 232 = waitevent */
    "modwatch",            /* 233 = modwatch */
    "getxattr",            /* 234 = getxattr */
    "fgetxattr",           /* 235 = fgetxattr */
    "setxattr",            /* 236 = setxattr */
    "fsetxattr",           /* 237 = fsetxattr */
    "removexattr",         /* 238 = removexattr */
    "fremovexattr",        /* 239 = fremovexattr */
    "listxattr",           /* 240 = listxattr */
    "flistxattr",          /* 241 = flistxattr */
    "fsctl",               /* 242 = fsctl */
    "initgroups",          /* 243 = initgroups */
    "posix_spawn",         /* 244 = posix_spawn */
    "ffsctl",              /* 245 = ffsctl */
    "#246",                /* 246 = */
#if NFSCLIENT
    "nfsclnt", /* 247 = nfsclnt */
#else
    "#247", /* 247 = */
#endif
#if NFSSERVER
    "fhopen", /* 248 = fhopen */
#else
    "#248", /* 248 = */
#endif
    "#249",     /* 249 = */
    "minherit", /* 250 = minherit */
#if SYSV_SEM
    "semsys", /* 251 = semsys */
#else
    "#251", /* 251 = */
#endif
#if SYSV_MSG
    "msgsys", /* 252 = msgsys */
#else
    "#252", /* 252 = */
#endif
#if SYSV_SHM
    "shmsys", /* 253 = shmsys */
#else
    "#253", /* 253 = */
#endif
#if SYSV_SEM
    "semctl", /* 254 = semctl */
    "semget", /* 255 = semget */
    "semop",  /* 256 = semop */
    "#257",   /* 257 = old semconfig */
#else
    "#254", /* 254 = */
    "#255", /* 255 = */
    "#256", /* 256 = */
    "#257", /* 257 = */
#endif
#if SYSV_MSG
    "msgctl", /* 258 = msgctl */
    "msgget", /* 259 = msgget */
    "msgsnd", /* 260 = msgsnd */
    "msgrcv", /* 261 = msgrcv */
#else
    "#258", /* 258 = */
    "#259", /* 259 = */
    "#260", /* 260 = */
    "#261", /* 261 = */
#endif
#if SYSV_SHM
    "shmat",  /* 262 = shmat */
    "shmctl", /* 263 = shmctl */
    "shmdt",  /* 264 = shmdt */
    "shmget", /* 265 = shmget */
#else
    "#262", /* 262 = */
    "#263", /* 263 = */
    "#264", /* 264 = */
    "#265", /* 265 = */
#endif
    "shm_open",        /* 266 = shm_open */
    "shm_unlink",      /* 267 = shm_unlink */
    "sem_open",        /* 268 = sem_open */
    "sem_close",       /* 269 = sem_close */
    "sem_unlink",      /* 270 = sem_unlink */
    "sem_wait",        /* 271 = sem_wait */
    "sem_trywait",     /* 272 = sem_trywait */
    "sem_post",        /* 273 = sem_post */
    "sysctlbyname",    /* 274 = sysctlbyname */
    "#275",            /* 275 = old sem_init */
    "#276",            /* 276 = old sem_destroy */
    "open_extended",   /* 277 = open_extended */
    "umask_extended",  /* 278 = umask_extended */
    "stat_extended",   /* 279 = stat_extended */
    "lstat_extended",  /* 280 = lstat_extended */
    "fstat_extended",  /* 281 = fstat_extended */
    "chmod_extended",  /* 282 = chmod_extended */
    "fchmod_extended", /* 283 = fchmod_extended */
    "access_extended", /* 284 = access_extended */
    "settid",          /* 285 = settid */
    "gettid",          /* 286 = gettid */
    "setsgroups",      /* 287 = setsgroups */
    "getsgroups",      /* 288 = getsgroups */
    "setwgroups",      /* 289 = setwgroups */
    "getwgroups",      /* 290 = getwgroups */
    "mkfifo_extended", /* 291 = mkfifo_extended */
    "mkdir_extended",  /* 292 = mkdir_extended */
#if CONFIG_EXT_RESOLVER
    "identitysvc", /* 293 = identitysvc */
#else
    "#293", /* 293 = */
#endif
    "shared_region_check_np", /* 294 = shared_region_check_np */
    "#295",                   /* 295 = old shared_region_map_np */
    "vm_pressure_monitor",    /* 296 = vm_pressure_monitor */
#if PSYNCH
    "psynch_rw_longrdlock",  /* 297 = psynch_rw_longrdlock */
    "psynch_rw_yieldwrlock", /* 298 = psynch_rw_yieldwrlock */
    "psynch_rw_downgrade",   /* 299 = psynch_rw_downgrade */
    "psynch_rw_upgrade",     /* 300 = psynch_rw_upgrade */
    "psynch_mutexwait",      /* 301 = psynch_mutexwait */
    "psynch_mutexdrop",      /* 302 = psynch_mutexdrop */
    "psynch_cvbroad",        /* 303 = psynch_cvbroad */
    "psynch_cvsignal",       /* 304 = psynch_cvsignal */
    "psynch_cvwait",         /* 305 = psynch_cvwait */
    "psynch_rw_rdlock",      /* 306 = psynch_rw_rdlock */
    "psynch_rw_wrlock",      /* 307 = psynch_rw_wrlock */
    "psynch_rw_unlock",      /* 308 = psynch_rw_unlock */
    "psynch_rw_unlock2",     /* 309 = psynch_rw_unlock2 */
#else
    "#297", /* 297 = old reset_shared_file */
    "#298", /* 298 = old new_system_shared_regions */
    "#299", /* 299 = old shared_region_map_file_np */
    "#300", /* 300 = old shared_region_make_private_np */
    "#301", /* 301 = */
    "#302", /* 302 = */
    "#303", /* 303 = */
    "#304", /* 304 = */
    "#305", /* 305 = */
    "#306", /* 306 = */
    "#307", /* 307 = */
    "#308", /* 308 = */
    "#309", /* 309 = */
#endif
    "getsid",          /* 310 = getsid */
    "settid_with_pid", /* 311 = settid_with_pid */
#if PSYNCH
    "psynch_cvclrprepost", /* 312 = psynch_cvclrprepost */
#else
    "#312", /* 312 = old __pthread_cond_timedwait */
#endif
    "aio_fsync",              /* 313 = aio_fsync */
    "aio_return",             /* 314 = aio_return */
    "aio_suspend",            /* 315 = aio_suspend */
    "aio_cancel",             /* 316 = aio_cancel */
    "aio_error",              /* 317 = aio_error */
    "aio_read",               /* 318 = aio_read */
    "aio_write",              /* 319 = aio_write */
    "lio_listio",             /* 320 = lio_listio */
    "#321",                   /* 321 = old __pthread_cond_wait */
    "iopolicysys",            /* 322 = iopolicysys */
    "process_policy",         /* 323 = process_policy */
    "mlockall",               /* 324 = mlockall */
    "munlockall",             /* 325 = munlockall */
    "#326",                   /* 326 = */
    "issetugid",              /* 327 = issetugid */
    "__pthread_kill",         /* 328 = __pthread_kill */
    "__pthread_sigmask",      /* 329 = __pthread_sigmask */
    "__sigwait",              /* 330 = __sigwait */
    "__disable_threadsignal", /* 331 = __disable_threadsignal */
    "__pthread_markcancel",   /* 332 = __pthread_markcancel */
    "__pthread_canceled",     /* 333 = __pthread_canceled */
    "__semwait_signal",       /* 334 = __semwait_signal */
    "#335",                   /* 335 = old utrace */
    "proc_info",              /* 336 = proc_info */
#if SENDFILE
    "sendfile", /* 337 = sendfile */
#else /* !SENDFILE */
    "#337", /* 337 = */
#endif /* SENDFILE */
    "stat64",           /* 338 = stat64 */
    "fstat64",          /* 339 = fstat64 */
    "lstat64",          /* 340 = lstat64 */
    "stat64_extended",  /* 341 = stat64_extended */
    "lstat64_extended", /* 342 = lstat64_extended */
    "fstat64_extended", /* 343 = fstat64_extended */
    "getdirentries64",  /* 344 = getdirentries64 */
    "statfs64",         /* 345 = statfs64 */
    "fstatfs64",        /* 346 = fstatfs64 */
    "getfsstat64",      /* 347 = getfsstat64 */
    "__pthread_chdir",  /* 348 = __pthread_chdir */
    "__pthread_fchdir", /* 349 = __pthread_fchdir */
    "audit",            /* 350 = audit */
    "auditon",          /* 351 = auditon */
    "#352",             /* 352 = */
    "getauid",          /* 353 = getauid */
    "setauid",          /* 354 = setauid */
    "#355",             /* 355 = old getaudit */
    "#356",             /* 356 = old setaudit */
    "getaudit_addr",    /* 357 = getaudit_addr */
    "setaudit_addr",    /* 358 = setaudit_addr */
    "auditctl",         /* 359 = auditctl */
#if CONFIG_WORKQUEUE
    "bsdthread_create",    /* 360 = bsdthread_create */
    "bsdthread_terminate", /* 361 = bsdthread_terminate */
#else
    "#360", /* 360 = */
    "#361", /* 361 = */
#endif /* CONFIG_WORKQUEUE */
    "kqueue", /* 362 = kqueue */
    "kevent", /* 363 = kevent */
    "lchown", /* 364 = lchown */
    "#365",   /* 365 = old stack_snapshot */
#if CONFIG_WORKQUEUE
    "bsdthread_register", /* 366 = bsdthread_register */
    "workq_open",         /* 367 = workq_open */
    "workq_kernreturn",   /* 368 = workq_kernreturn */
#else
    "#366", /* 366 = */
    "#367", /* 367 = */
    "#368", /* 368 = */
#endif /* CONFIG_WORKQUEUE */
    "kevent64", /* 369 = kevent64 */
#if OLD_SEMWAIT_SIGNAL
    "__old_semwait_signal",          /* 370 = __old_semwait_signal */
    "__old_semwait_signal_nocancel", /* 371 = __old_semwait_signal_nocancel */
#else
    "#370", /* 370 = old __semwait_signal */
    "#371", /* 371 = old __semwait_signal */
#endif
    "thread_selfid", /* 372 = thread_selfid */
    "ledger",        /* 373 = ledger */
    "kevent_qos",    /* 374 = kevent_qos */
    "kevent_id",     /* 375 = kevent_id */
    "#376",          /* 376 = */
    "#377",          /* 377 = */
    "#378",          /* 378 = */
    "#379",          /* 379 = */
    "__mac_execve",  /* 380 = __mac_execve */
#if CONFIG_MACF
    "__mac_syscall",  /* 381 = __mac_syscall */
    "__mac_get_file", /* 382 = __mac_get_file */
    "__mac_set_file", /* 383 = __mac_set_file */
    "__mac_get_link", /* 384 = __mac_get_link */
    "__mac_set_link", /* 385 = __mac_set_link */
    "__mac_get_proc", /* 386 = __mac_get_proc */
    "__mac_set_proc", /* 387 = __mac_set_proc */
    "__mac_get_fd",   /* 388 = __mac_get_fd */
    "__mac_set_fd",   /* 389 = __mac_set_fd */
    "__mac_get_pid",  /* 390 = __mac_get_pid */
#else
    "#381", /* 381 = */
    "#382", /* 382 = */
    "#383", /* 383 = */
    "#384", /* 384 = */
    "#385", /* 385 = */
    "#386", /* 386 = */
    "#387", /* 387 = */
    "#388", /* 388 = */
    "#389", /* 389 = */
    "#390", /* 390 = */
#endif
    "#391",             /* 391 = */
    "#392",             /* 392 = */
    "#393",             /* 393 = */
    "pselect",          /* 394 = pselect */
    "pselect_nocancel", /* 395 = pselect_nocancel */
    "read_nocancel",    /* 396 = read_nocancel */
    "write_nocancel",   /* 397 = write_nocancel */
    "open_nocancel",    /* 398 = open_nocancel */
    "close_nocancel",   /* 399 = close_nocancel */
    "wait4_nocancel",   /* 400 = wait4_nocancel */
#if SOCKETS
    "recvmsg_nocancel",  /* 401 = recvmsg_nocancel */
    "sendmsg_nocancel",  /* 402 = sendmsg_nocancel */
    "recvfrom_nocancel", /* 403 = recvfrom_nocancel */
    "accept_nocancel",   /* 404 = accept_nocancel */
#else
    "#401", /* 401 = */
    "#402", /* 402 = */
    "#403", /* 403 = */
    "#404", /* 404 = */
#endif /* SOCKETS */
    "msync_nocancel",  /* 405 = msync_nocancel */
    "fcntl_nocancel",  /* 406 = fcntl_nocancel */
    "select_nocancel", /* 407 = select_nocancel */
    "fsync_nocancel",  /* 408 = fsync_nocancel */
#if SOCKETS
    "connect_nocancel", /* 409 = connect_nocancel */
#else
    "#409", /* 409 = */
#endif /* SOCKETS */
    "sigsuspend_nocancel", /* 410 = sigsuspend_nocancel */
    "readv_nocancel",      /* 411 = readv_nocancel */
    "writev_nocancel",     /* 412 = writev_nocancel */
#if SOCKETS
    "sendto_nocancel", /* 413 = sendto_nocancel */
#else
    "#413", /* 413 = */
#endif /* SOCKETS */
    "pread_nocancel",  /* 414 = pread_nocancel */
    "pwrite_nocancel", /* 415 = pwrite_nocancel */
    "waitid_nocancel", /* 416 = waitid_nocancel */
    "poll_nocancel",   /* 417 = poll_nocancel */
#if SYSV_MSG
    "msgsnd_nocancel", /* 418 = msgsnd_nocancel */
    "msgrcv_nocancel", /* 419 = msgrcv_nocancel */
#else
    "#418", /* 418 = */
    "#419", /* 419 = */
#endif
    "sem_wait_nocancel",         /* 420 = sem_wait_nocancel */
    "aio_suspend_nocancel",      /* 421 = aio_suspend_nocancel */
    "__sigwait_nocancel",        /* 422 = __sigwait_nocancel */
    "__semwait_signal_nocancel", /* 423 = __semwait_signal_nocancel */
    "__mac_mount",               /* 424 = __mac_mount */
#if CONFIG_MACF
    "__mac_get_mount", /* 425 = __mac_get_mount */
#else
    "#425", /* 425 = */
#endif
    "__mac_getfsstat",    /* 426 = __mac_getfsstat */
    "fsgetpath",          /* 427 = fsgetpath private fsgetpath ( File Manager SPI ) */
    "audit_session_self", /* 428 = audit_session_self */
    "audit_session_join", /* 429 = audit_session_join */
    "fileport_makeport",  /* 430 = fileport_makeport */
    "fileport_makefd",    /* 431 = fileport_makefd */
    "audit_session_port", /* 432 = audit_session_port */
    "pid_suspend",        /* 433 = pid_suspend */
    "pid_resume",         /* 434 = pid_resume */
#if CONFIG_EMBEDDED
    "pid_hibernate", /* 435 = pid_hibernate */
#else
    "#435", /* 435 = */
#endif
#if SOCKETS
    "pid_shutdown_sockets", /* 436 = pid_shutdown_sockets */
#else
    "#436", /* 436 = */
#endif
    "#437",                           /* 437 = old shared_region_slide_np */
    "shared_region_map_and_slide_np", /* 438 = shared_region_map_and_slide_np */
    "kas_info",                       /* 439 = kas_info */
#if CONFIG_MEMORYSTATUS
    "memorystatus_control", /* 440 = memorystatus_control */
#else
    "#440", /* 440 = */
#endif
    "guarded_open_np",     /* 441 = guarded_open_np */
    "guarded_close_np",    /* 442 = guarded_close_np */
    "guarded_kqueue_np",   /* 443 = guarded_kqueue_np */
    "change_fdguard_np",   /* 444 = change_fdguard_np */
    "usrctl",              /* 445 = usrctl */
    "proc_rlimit_control", /* 446 = proc_rlimit_control */
#if SOCKETS
    "connectx",        /* 447 = connectx */
    "disconnectx",     /* 448 = disconnectx */
    "peeloff",         /* 449 = peeloff */
    "socket_delegate", /* 450 = socket_delegate */
#else
    "#447", /* 447 = */
    "#448", /* 448 = */
    "#449", /* 449 = */
    "#450", /* 450 = */
#endif /* SOCKETS */
    "telemetry", /* 451 = telemetry */
#if CONFIG_PROC_UUID_POLICY
    "proc_uuid_policy", /* 452 = proc_uuid_policy */
#else
    "#452", /* 452 = */
#endif
#if CONFIG_MEMORYSTATUS
    "memorystatus_get_level", /* 453 = memorystatus_get_level */
#else
    "#453", /* 453 = */
#endif
    "system_override", /* 454 = system_override */
    "vfs_purge",       /* 455 = vfs_purge */
    "sfi_ctl",         /* 456 = sfi_ctl */
    "sfi_pidctl",      /* 457 = sfi_pidctl */
#if CONFIG_COALITIONS
    "coalition",      /* 458 = coalition */
    "coalition_info", /* 459 = coalition_info */
#else
    "#458", /* 458 = */
    "#459", /* 459 = */
#endif /* COALITIONS */
#if NECP
    "necp_match_policy", /* 460 = necp_match_policy */
#else
    "#460", /* 460 = */
#endif /* NECP */
    "getattrlistbulk", /* 461 = getattrlistbulk */
    "clonefileat",     /* 462 = clonefileat */
    "openat",          /* 463 = openat */
    "openat_nocancel", /* 464 = openat_nocancel */
    "renameat",        /* 465 = renameat */
    "faccessat",       /* 466 = faccessat */
    "fchmodat",        /* 467 = fchmodat */
    "fchownat",        /* 468 = fchownat */
    "fstatat",         /* 469 = fstatat */
    "fstatat64",       /* 470 = fstatat64 */
    "linkat",          /* 471 = linkat */
    "unlinkat",        /* 472 = unlinkat */
    "readlinkat",      /* 473 = readlinkat */
    "symlinkat",       /* 474 = symlinkat */
    "mkdirat",         /* 475 = mkdirat */
    "getattrlistat",   /* 476 = getattrlistat */
    "proc_trace_log",  /* 477 = proc_trace_log */
    "bsdthread_ctl",   /* 478 = bsdthread_ctl */
    "openbyid_np",     /* 479 = openbyid_np */
#if SOCKETS
    "recvmsg_x", /* 480 = recvmsg_x */
    "sendmsg_x", /* 481 = sendmsg_x */
#else
    "#480", /* 480 = */
    "#481", /* 481 = */
#endif /* SOCKETS */
    "thread_selfusage", /* 482 = thread_selfusage */
#if CONFIG_CSR
    "csrctl", /* 483 = csrctl */
#else
    "#483", /* 483 = */
#endif /* CSR */
    "guarded_open_dprotected_np", /* 484 = guarded_open_dprotected_np */
    "guarded_write_np",           /* 485 = guarded_write_np */
    "guarded_pwrite_np",          /* 486 = guarded_pwrite_np */
    "guarded_writev_np",          /* 487 = guarded_writev_np */
    "renameatx_np",               /* 488 = renameatx_np */
#if CONFIG_CODE_DECRYPTION
    "mremap_encrypted", /* 489 = mremap_encrypted */
#else
    "#489", /* 489 = */
#endif
#if NETWORKING
    "netagent_trigger", /* 490 = netagent_trigger */
#else
    "#490", /* 490 = */
#endif /* NETWORKING */
    "stack_snapshot_with_config", /* 491 = stack_snapshot_with_config */
#if CONFIG_TELEMETRY
    "microstackshot", /* 492 = microstackshot */
#else
    "#492", /* 492 = */
#endif /* CONFIG_TELEMETRY */
#if PGO
    "grab_pgo_data", /* 493 = grab_pgo_data */
#else
    "#493", /* 493 = */
#endif
#if CONFIG_PERSONAS
    "persona", /* 494 = persona */
#else
    "#494", /* 494 = */
#endif
    "#495",              /* 495 = */
    "#496",              /* 496 = */
    "#497",              /* 497 = */
    "#498",              /* 498 = */
    "work_interval_ctl", /* 499 = work_interval_ctl */
    "getentropy",        /* 500 = getentropy */
#if NECP
    "necp_open",          /* 501 = necp_open */
    "necp_client_action", /* 502 = necp_client_action */
#else
    "#501", /* 501 = */
    "#502", /* 502 = */
#endif /* NECP */
    "#503",                   /* 503 = */
    "#504",                   /* 504 = */
    "#505",                   /* 505 = */
    "#506",                   /* 506 = */
    "#507",                   /* 507 = */
    "#508",                   /* 508 = */
    "#509",                   /* 509 = */
    "#510",                   /* 510 = */
    "#511",                   /* 511 = */
    "#512",                   /* 512 = */
    "#513",                   /* 513 = */
    "#514",                   /* 514 = */
    "ulock_wait",             /* 515 = ulock_wait */
    "ulock_wake",             /* 516 = ulock_wake */
    "fclonefileat",           /* 517 = fclonefileat */
    "fs_snapshot",            /* 518 = fs_snapshot */
    "#519",                   /* 519 = */
    "terminate_with_payload", /* 520 = terminate_with_payload */
    "abort_with_payload",     /* 521 = abort_with_payload */
#if NECP
    "necp_session_open",   /* 522 = necp_session_open */
    "necp_session_action", /* 523 = necp_session_action */
#else /* NECP */
    "#522", /* 522 = */
    "#523", /* 523 = */
#endif /* NECP */
    "setattrlistat",         /* 524 = setattrlistat */
    "net_qos_guideline",     /* 525 = net_qos_guideline */
    "fmount",                /* 526 = fmount */
    "ntp_adjtime",           /* 527 = ntp_adjtime */
    "ntp_gettime",           /* 528 = ntp_gettime */
    "os_fault_with_payload", /* 529 = os_fault_with_payload */
#if CONFIG_WORKQUEUE
    "kqueue_workloop_ctl", /* 530 = kqueue_workloop_ctl */
#else
    "#530", /* 530 = */
#endif // CONFIG_WORKQUEUE
    "__mach_bridge_remote_time", /* 531 = __mach_bridge_remote_time */
#if CONFIG_COALITIONS
    "coalition_ledger", /* 532 = coalition_ledger */
#else
    "#532", /* 532 = */
#endif // CONFIG_COALITIONS
    "log_data",                      /* 533 = log_data */
    "memorystatus_available_memory", /* 534 = memorystatus_available_memory */
};